"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeSdJwtVc = void 0;
const utils_1 = require("@sd-jwt/utils");
const fromCompact_1 = require("./fromCompact");
const utils_2 = require("@sd-jwt/utils");
const calculateDigest_1 = require("../disclosures/calculateDigest");
const toArray_1 = require("../disclosures/toArray");
const decodeSdJwtVc = (compact, hasher) => {
    var _a, _b;
    const { header, payload, signature, keyBinding, disclosures } = (0, fromCompact_1.sdJwtVcFromCompact)(compact);
    const hasherAlgorithm = (_a = (0, utils_2.getValueByKeyAnyLevel)(payload, '_sd_alg')) !== null && _a !== void 0 ? _a : utils_1.HasherAlgorithm.Sha256;
    const disclosureWithDigests = (_b = disclosures === null || disclosures === void 0 ? void 0 : disclosures.map((d) => ({
        digest: (0, calculateDigest_1.disclosureCalculateDigest)(d, hasherAlgorithm, hasher),
        decoded: d,
        encoded: (0, toArray_1.disclosureToArray)(d)
    }))) !== null && _b !== void 0 ? _b : [];
    return {
        compactSdJwtVc: compact,
        signedPayload: payload,
        header,
        signature,
        keyBinding,
        disclosures: disclosureWithDigests,
        decodedPayload: (0, utils_2.swapClaims)(payload, disclosureWithDigests.map((d) => (Object.assign(Object.assign({}, d.decoded), { digest: d.digest }))))
    };
};
exports.decodeSdJwtVc = decodeSdJwtVc;
//# sourceMappingURL=decode.js.map